subroutine scatterspl(x,y,z,w,n,kspl,sspl,xmin,xmax,ymin,ymax, &
                        tx,nknt_x,ty,nknt_y,coeff,ierr)
  use itm_types, only : r8
  implicit none
  integer :: n
  real(r8), dimension(n) :: x, y, z
  real(r8), dimension(n) :: w
  integer :: kspl
  real(r8) :: sspl
  real(r8) :: xmin, xmax, ymin, ymax
  real(r8), dimension(nknt_x) :: tx
  real(r8), dimension(nknt_y) :: ty
  integer :: nknt_x, nknt_y
  real(r8), dimension(nknt_x*nknt_y) :: coeff
  integer :: ierr

  integer :: iopt
  real(r8), parameter :: eps_r8=epsilon(1._r8)
  real(r8) :: resid
  integer :: u,v,km,ne,b1,b2,lwrk1,lwrk2,kwrk,nxest,nyest
  real(r8), dimension(:), allocatable :: tx_tmp,ty_tmp
  real(r8), dimension(:), allocatable :: wrk1, wrk2
  integer, dimension(:), allocatable :: iwrk

  nxest=nknt_x
  nyest=nknt_y
  ne = max(nxest,nyest)
  allocate(tx_tmp(ne),ty_tmp(ne))

  km = kspl+1
  u = nxest-km
  v = nyest-km
  b1 = kspl*min(u,v)+kspl+1
  b2 = (kspl+1)*min(u,v)+1
  lwrk1 = u*v*(2+b1+b2)+2*(u+v+km*(n+ne)+ne-2*kspl)+b2+1
  lwrk2 = u*v*(b2+1)+b2
  kwrk = n+(nknt_x-2*kspl-1)*(nknt_y-2*kspl-1)
  allocate(wrk1(lwrk1),wrk2(lwrk2),iwrk(kwrk))

  iopt=0
  call surfit(iopt,n,x,y,z,w,xmin,xmax,ymin,ymax,kspl,kspl,sspl, &
              nxest,nyest,ne,eps_r8,nknt_x,tx_tmp,nknt_y,ty_tmp, &
              coeff,resid,wrk1,lwrk1,wrk2,lwrk2,iwrk,kwrk,ierr)
  tx(1:nknt_x)=tx_tmp(1:nknt_x)
  ty(1:nknt_y)=ty_tmp(1:nknt_y)

  deallocate(wrk1,wrk2,iwrk)
  deallocate(tx_tmp,ty_tmp)

end subroutine scatterspl
